//<editor-fold defaultstate="collapsed" desc=" COPYRIGHT AND LICENSE ">
/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.templates.visualization.guis;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import org.visnow.jscic.Field;
import org.visnow.vn.geometries.gui.PresentationGUI;
import org.visnow.vn.system.swing.CustomSizePanel;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class FieldVisualizationGUI extends javax.swing.JPanel
{
    private JPanel computePanel;

    protected Field inField;
    protected CardLayout cL;

    /**
     * Creates new form FieldVisualizationGUI
     */
    public FieldVisualizationGUI()
    {
        initComponents();
        postInitComponents();
    }

    private void postInitComponents()
    {
        computePanel = new CustomSizePanel(new BorderLayout());
        computeScrollPane.setViewportView(computePanel);
        hidePresentation();
    }

    public void hidePresentation()
    {
        mainPane.remove(presentationGUI);
    }

    public void showPresentation()
    {
        if (mainPane.indexOfComponent(presentationGUI) == -1)
            mainPane.addTab("Presentation", presentationGUI);
    }
    
    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT
     * modify this code. The content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        computeScrollPane = new javax.swing.JScrollPane();
        mainPane = new javax.swing.JTabbedPane();
        presentationGUI = new org.visnow.vn.geometries.gui.PresentationGUI();

        computeScrollPane.setName("computeScrollPane"); // NOI18N

        setLayout(new java.awt.BorderLayout());

        mainPane.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        mainPane.setName("mainPane"); // NOI18N

        presentationGUI.setName("presentationGUI"); // NOI18N
        mainPane.addTab("Presentation", presentationGUI);

        add(mainPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    public void addComputeGUI(JPanel gui, String title)
    {
        computePanel.removeAll();
        computePanel.add(gui, BorderLayout.CENTER);
        mainPane.insertTab(title, null, computeScrollPane, "", 0);
        mainPane.setSelectedIndex(0);
    }
    
    public void addComputeGUI(JPanel gui)
    {
        addComputeGUI(gui, "Computation");
    }
    
    public void insertAdditionalGUI(JPanel gui, String title)
    {
        JPanel additionalPanel = new CustomSizePanel(new BorderLayout());
        JScrollPane additionalScrollPane = new javax.swing.JScrollPane();
        additionalScrollPane.setViewportView(additionalPanel);
        additionalPanel.add(gui, BorderLayout.NORTH);
        mainPane.insertTab(title, null, additionalScrollPane, "", 1);
    }

    public PresentationGUI getPresentationGUI()
    {
        return presentationGUI;
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JScrollPane computeScrollPane;
    protected javax.swing.JTabbedPane mainPane;
    protected org.visnow.vn.geometries.gui.PresentationGUI presentationGUI;
    // End of variables declaration//GEN-END:variables

}
